/* Copyright (C) 1997 Tom Wheeley, see file COPYING for details */

/*
 * Castrate
 *
 * Simple Editor password finding program.  Displays Editor filenames and
 * passwords stored in an `ALL' CaS file.
 *
 * Needs to be an ALL .CAS file as otherwise the calculator asks for the
 * password upon transmission.
 *
 */

#define CAS_DEFINE_GLOBALS
#define NO_CASTLE

#include "cas.h"
#include "misc.h"
#include "token.h"
#include "castrate.h"

int main(int argc, char *argv[])
{
  FILE *f;
  unsigned char chunk1;
  unsigned char chunk2;
  unsigned char haspw;
  long size;
  data_t data;
  char n[14],p[14];
  char *token;
  int i;

  printf("castrate %s\n",CAS_VER_STR);

  if (!--argc) {
    exit(EXIT_CMD);
  }

  flags.list.tokfile=TOKEN_TOKFILE_CTF;
  flags.list.format=fCTF;
  flags.list.set=TRUE;
  InitTokens();
  
  putchar('\n');

  if (!(f=fopen(*++argv,"rb"))) {
    Msg(EXIT_FILE,"main","Unable to open `%s'",*argv);
  }

  chunk1=getc(f);chunk1=getc(f);chunk2=getc(f);
  if (chunk1!='A'||chunk2!='L') {
    Msg(EXIT_FILE,"main","Not an `ALL' .cas file: `%c%c'",chunk1,chunk2);
  }

  tsys_fseek(f,44,SEEK_SET);
  fread(&chunk1,1,1,f);
  fread(&chunk2,1,1,f);
  size = chunk1 * 256 + chunk2;
  tsys_fseek(f,226+size,SEEK_CUR);

  for(;;) {
    if (getc(f)!=':') break;
    if (getc(f)!='F') break;
    switch((haspw=getc(f))) {
      case 'N': printf("  ");break;
      case 'P': printf("* ");break;
      default:haspw='!';
    }
    if (haspw=='!') break;
    getc(f);fread(&chunk1,1,1,f);fread(&chunk2,1,1,f);getc(f);getc(f);
    size = chunk1 * 256 + chunk2;

    fread(&data,sizeof(data),1,f);

    strncpy(n,data.name,12);n[12]='\xff';n[13]='\0';
    for (i=13;i>0;i--)
      switch (n[i]) {
        case '\xff': if (n[i-1]=='\xff') n[i]=' '; else n[i]='\"'; break;
        default:
          token=CodeToToken((unsigned char)n[i],TRUE);
          if (!(token[1])) n[i]=*token;
          else Msg(M_DEBUG,"token","token too long: `%s'",token);
      }

    strncpy(p,data.pw,12);p[12]='\xff';p[13]='\0';
    for (i=0;i<13;i++)
      switch(p[i]) {
        case '\xff': p[i]='\0';break;
        default:
          token=CodeToToken((unsigned char)p[i],TRUE);
          if (!(token[1])) p[i]=*token;
      }

    printf("\"%s",n);
    if (haspw=='P')
      printf("    [%s]",p);
    putchar('\n');

    fseek(f,size+8,SEEK_CUR);
  }

  fclose(f);
  return 0;
}

void tsys_fseek(FILE *f,long offset,int mode)
{
  if (fseek(f,offset,mode)) {
    Msg(EXIT_FILE,"fseek","Unable to seek to position %ld",offset);
  }
}


/* end of castrate.c */
