/* Copyright (C) 1997 Tom Wheeley, see file COPYING for details */

/*
 * COMMSYS.H    Communications module header
 *
 * This should be included in any serial drivers written for CaS, and all the
 * functions detailed below should be provided to some extent.
 */

#ifndef _CAS_COMMSYS_H_
#define _CAS_COMMSYS_H_

int     COMsysInit(char *filename, int baud, char parity, int handshake);
void    COMsysClose(void);
void    COMsysPutChar(unsigned char data);
unsigned char   COMsysGetChar(void);
unsigned char   COMsysGetCharTimeout(int *success_r,unsigned int modifier);

/* communications settings */
#define CASPORT_ODD             'O'
#define CASPORT_NONE            'N'
#define CASPORT_EVEN            'E'

/* Handshaking (used to power interface) */
#define CASPORT_RTS             1
#define CASPORT_DTR             2

#ifdef _CAS_FCOM_C_
int flg_bytes=0;
#else
extern int flg_bytes;
#endif

#endif /* _CAS_COMMSYS_H_ */

/* end of commsys.h */
