/* Copyright (C) 1997 Tom Wheeley, see file COPYING for details */

/*
 * CONVERT.H  Type->Type conversions
 *
 *            Screenshot->Program written by Tom Lynn and ported to C
 *                                by Tom Wheeley
 */

#ifndef _CAS_CONVERT_H_
#define _CAS_CONVERT_H_

void ConvertData(int after, casinfo *info);
#define ConvertBefore(x)    ConvertData(0,(x));
#define ConvertAfter(x)     ConvertData(1,(x));

#ifdef _CAS_CONVERT_C_

typedef struct convprocs_t {
  types from;
  types to;
  void (*convertor)(casinfo *);
} convprocs_t;

/*
 * Declare the interface functions, and put them in the capabilities
 * array.  Only simple conversions will be in these functions, more complex
 * ones are subtended out to functions in other source files, called by
 * the interface routines below
 */

/* You need an ANSI C preprocessor for the following trickery */

#define DC(x,y)     static void cv_##x##_##y (casinfo *info)
#define CV(x,y)     {t##x,t##y,cv_##x##_##y}

DC(SSMono,OldProg);
DC(OldProg,Editor);
DC(SSMono,SSCol);

convprocs_t convprocs[]={
  CV(SSMono,OldProg),
  CV(OldProg,Editor),
  CV(SSMono,SSCol),
  {tEnd,tEnd,NULL}
};

#undef DC
#undef CV

#endif /* _CAS_CONVERT_C_ */

#endif /* !_CAS_CONVERT_H_ */

/* end of convert.h */

