/* Copyright (C) 1997 Tom Wheeley, see file COPYING for details */

/*
 * MAIN.H  Parameter reading, and calling of input, output and list fn's
 */
 
#ifndef _CAS_MAIN_H_
#define _CAS_MAIN_H_

#define CONV_BEFORE         1
#define CONV_AFTER          2

#define LIST_TYPES			1
#define LIST_DATA			2

#ifdef _CAS_MAIN_C_

formats format_from_filename(char *filename);
char *shorten_long_opt(char *lo);

typedef struct longopts_s {
  char *lo;
  char so;
} longopts_t;

/*
 * because of the way shorten_long_opt() works, options which are shorter
 * but otherwise identical to other options must appear AFTER their longer
 * counterparts in this array.
 */

longopts_t long_options[] = {
  {"help",'h'},
  {"version",'V'},
  {"input",'i'},
  {"infile",'i'},
  {"output",'o'},
  {"outfile",'o'},
  {"list",'l'},
  {"display",'l'},
  {"model",'m'},
  {"convert-after",'C'},
  {"convert",'c'},
  {"terse",'t'},
  {"verbose",'v'},
  {"debug",'d'},
  {"castle",'e'},
  {"pager",'p'},
  {NULL,'\0'}
};

#ifdef PROPER_SPELLING
#define CAS_BANNER  "This is CaS, Version 3E+8 (" CAS_VER_STR ")"
#else
#define CAS_BANNER  "This is CaS, Version 3E+8 (" CAS_VER_STR "-us)"
#endif

#endif /* _CAS_MAIN_C_ */

#endif /* _CAS_MAIN_H_ */

/* end of main.h */
