/* Copyright (C) 1997 Tom Wheeley, see file COPYING for details */

/*
 * SRAW.C  Routines for reading/writing raw CAS data
 */
 
#define _CAS_SRAW_C_

#include "cas.h"
#include "misc.h"
#include "sraw.h"

void ReadData_Raw(void *firsthdr, casinfo *info, iostruct *io)
{
  casinfo *curblk;
  unsigned char *data;
  size_t datalen;
  long datapos=0;

  curblk=info->next=tsys_malloc(sizeof (casinfo));
  curblk->type=tRaw;
  curblk->next=NULL;
  curblk->s.raw.cooked=0;
  curblk->data=NULL;
  curblk->length=0;

  data=tsys_malloc(CAS_MEMSIZE);

  /* copy first header into a raw block */
  if (read_datalen > 0) {
    *data=read_colon;
    memcpy(data+1,firsthdr,read_datalen);
    data[read_datalen + 1]=read_csum;
    datapos=read_datalen+2;
  } else {
    datapos=0;
  }

  /* copy all following blocks into the end of this block */

  for (;;) {
    datalen=(*io->readraw)(data+datapos, 0);
    if (datalen==0) {
      break;
    }
    datapos+=datalen;
  }

  curblk->data=tsys_realloc(data,datapos);
  curblk->length=datapos;
}


void WriteData_Raw(casinfo *info, iostruct *io)
{
  for(;info;info=info->next) {
    if (info->type==tRaw && info->length > 0)
      if (info->s.raw.cooked)
        (*io->writeblk)(info->data,info->length);
      else
        (*io->writeraw)(info->data,info->length);
  }
}

int Is_Raw(unsigned char *data)
{
  return 1;
}

/* end of sraw.c */
